#ifndef HARDWAREINFO_H
#define HARDWAREINFO_H

#include "hardwareinfostructs.h"
#include "../File/filehardwareinfo.h"

class HardwareInfo
{
public:
    HardwareInfo();
    virtual ~HardwareInfo();

public:
    enum EnumDeviceType
    {
        PZEMasterIV,
        ZKMasterIV,
        BDEMasterIV,
        MobilMasterIV,
        MDEBoxIV,
        AEMasterIV,
        TimeboyIV,
        ExklusivLineIV,
        FlexMasterIV,
        TimeboyMobilPZE,
            // Bis hier waren die Nummern identisch mit der HardwareInfo-Vorgngerversion.
        IPCExtensionA,
        EVOLine28,
        EVOLine43,
        IPCExtensionB,
        IPCExtensionC,
        ZKBox,
        IOBox,
        MobilBox,
        TimeboyTBDock,
        MobileTBDock,
        ZKKnoten
    };
public:
    void clear();

    bool importStructHardwareInfo( const StructHardwareInfo &info );
    StructHardwareInfo exportStructHardwareInfo() const;

    void setFileHardwareInfo( const FileHardwareInfo &file );
    FileHardwareInfo &fileHardwareInfo();

public:
    bool isMasterIV();
    bool isMasterIV( const StructHardwareInfo &info );


public:
    enum EnumHardwareConfigType
    {
        Mainboard,
        Module,
        ModuleWithPlaces,
        SubModule
    };

public:
    std::string deviceName();
    EnumDeviceType deviceType();

public:
    setItemBoard collectModuleIds( const setModuleId &ids );
    // Shorties
    setItemBoard moduleRS232Communication( const setModuleRS232Communication &module = moduleRS232Communication_all );
    setItemBoard moduleRS485Communication( const setModuleRS485Communication &module = moduleRS485Communication_all );
    setItemBoard moduleUSBCommunication( const setModuleUSBCommunication &module = moduleUSBCommunication_all );
    setItemBoard moduleLANCommunication( const setModuleLANCommunication &module = moduleLANCommunication_all );
    setItemBoard moduleWLANCommunication( const setModuleWLANCommunication &module = moduleWLANCommunication_all );
    setItemBoard moduleMobileCommunication( const setModuleMobileCommunication &module = moduleMobileCommunication_all );
    setItemBoard moduleBluetoothCommunication( const setModuleBluetoothCommunication &module = moduleBluetoothCommunication_all );
    setItemBoard moduleMMCCommunication( const setModuleMMCCommunication &module = moduleMMCCommunication_all );
    setItemBoard moduleUSBHostCommunication( const setModuleUSBHostCommunication &module = moduleUSBHostCommunication_all );

    setItemBoard moduleAccessControl( const setModuleAccessControl &module = moduleAccessControl_all );
    setItemBoard moduleBiokey( const setModuleBiokey &module = moduleBiokey_all );
    setItemBoard moduleGPS( const setModuleGPS &module = moduleGPS_all );

private:
    FileHardwareInfo _fileHardwareInfo;
};

#endif
